using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Infragistics.Win.Printing;
using Infragistics.Documents;
using Infragistics.Documents.Report;
using Infragistics.Documents.Report.Projection;
using Infragistics.Win;

using Infragistics.Documents.Report.QuickText;
using Infragistics.Documents.Report.Section;

using Infragistics.Documents.Utils;

namespace win_ultraprintdialog
{
    public partial class Form1 : Form
    {
            
        private Infragistics.Win.Misc.UltraButton ultraButton1;
        public Form1()
        {
            InitializeComponent();

            this.ultraButton1 = new Infragistics.Win.Misc.UltraButton();
            this.SuspendLayout();
            // 
            // ultraButton1
            // 
            this.ultraButton1.Location = new System.Drawing.Point(157, 47);
            this.ultraButton1.Name = "ultraButton1";
            this.ultraButton1.Size = new System.Drawing.Size(106, 37);
            this.ultraButton1.TabIndex = 0;
            this.ultraButton1.Text = "ultraButton1";
            this.ultraButton1.Click += new System.EventHandler(this.ultraButton1_Click);
            // 
            // Form1
            // 
            this.ClientSize = new System.Drawing.Size(292, 273);
            this.Controls.Add(this.ultraButton1);
            this.Name = "Form1";
            this.Text = "Form1";
            this.ResumeLayout(false);
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            StringBuilder sb = new StringBuilder("Complete this by estimating the average or projected monthly expenses at time case filed. Prorate any payments made biweekly,");
            sb.Append(" quarterly, semi-annually, or annually to show monthly rate. The average monthly expenses calculated on this form may differ from the deductions from income");
            sb.Append(" allowed on other forms.");

            Report r = new Report();
            ISection s = r.AddSection();
            s.PageMargins.All = (float)50;
            s.AddQuickText(sb.ToString());
            IGap g = s.AddGap();
            g.Height = new FixedHeight((float)72);
            s.AddQuickText(sb.ToString());
            Preview(r);
            r = null;
        }

        IProjectionPageCollection pages;
        UltraPrintPreviewDialog uPrvDlg = new UltraPrintPreviewDialog();

        int currentPrintPageNumber;
        public void Preview(Report Report)
        {
            uPrvDlg = new UltraPrintPreviewDialog(this.Container);

            Infragistics.Win.Printing.UltraPrintDocument ultraPrintDocument1 = new UltraPrintDocument();

            ultraPrintDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(ultraPrintDocument1_PrintPage);
            this.uPrvDlg.Document = ultraPrintDocument1;
            this.uPrvDlg.Printing += new PrintingEventHandler(uPrvDlg_Printing);
            this.pages = Report.Generate();
            this.currentPrintPageNumber = 0;            

            this.uPrvDlg.PreviewSettings.Zoom = (double)1; 

            //this.PreviewPDF.Document = ultraPrintDocument1;
            this.uPrvDlg.ShowDialog();

            ultraPrintDocument1.PrintPage -= new System.Drawing.Printing.PrintPageEventHandler(ultraPrintDocument1_PrintPage);
            this.uPrvDlg.Printing -= new PrintingEventHandler(uPrvDlg_Printing);
            ultraPrintDocument1.Dispose();
            ultraPrintDocument1 = null;
        }

        void uPrvDlg_Printing(object sender, PrintingEventArgs e)
        {
            currentPrintPageNumber = 0;
            e.Cancel = true;

            PrintDialog pd = new System.Windows.Forms.PrintDialog();
            pd.UseEXDialog = true;//required for some AMD processors
            pd.AllowPrintToFile = false;
            pd.AllowSelection = false;
            pd.AllowSomePages = false;
            pd.AllowCurrentPage = false;
            pd.ShowNetwork = false;
            pd.ShowHelp = false;

            if (pd.ShowDialog() == DialogResult.OK)
            {
                string printerName = pd.PrinterSettings.PrinterName;
                //rpt.Report.Print(printerName);
            }
        }

        private void ultraPrintDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            // Create a new Document Graphics object based on the printer page graphics. 
            Infragistics.Documents.Graphics.Graphics reportGraphics = new Infragistics.Documents.Graphics.Graphics(e.Graphics);

            // Save the state of the Graphics object So we can restore it later. 
            reportGraphics.SaveState();
            // Get the page margins in points. 
            float leftMarginInPoints = (e.MarginBounds.Left / 100f) * 72f;
            float topMarginInPoints = (e.MarginBounds.Top / 100f) * 72f;
            // Get the available print width and height in points. This is the size
            // of the printable area of the page inside the margins. 
            float availablePrintWidth = (e.MarginBounds.Width / 100f) * 72f;
            float availablePrintHeight = (e.MarginBounds.Height / 100f) * 72f;
            // Use a translate to shift the report page drawing inside the printer page margins. 
            // Get the currently printing report page.
            IProjectionPage reportPage = pages[this.currentPrintPageNumber];
            // Scale the report page so that it fits inside the available print area. 
            float widthRatio = availablePrintWidth / reportPage.Width;
            float heightRatio = availablePrintHeight / reportPage.Height;

            //reportGraphics.Scale(widthRatio, heightRatio);

            // Draw the page. 
            reportPage.Draw(reportGraphics);
            // Restore the Graphics settings. 
            reportGraphics.RestoreState();
            // Increment the page number. 
            currentPrintPageNumber++;
            // If this is the last page, set HasMorePages to false. 
            e.HasMorePages = currentPrintPageNumber < (pages.Count);

        }
         

    }
}
